<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2006 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------+
| Shoutbox 5.00 - Modded by Shedrock/Xandra 2007
+----------------------------------------------------*/
require_once "../maincore.php";
require_once BASEDIR."subheader.php";
require_once ADMIN."navigation.php";
include LOCALE.LOCALESET."admin/shoutbox.php";
require_once INFUSIONS."shoutbox_panel/parser.php";

if (!checkrights("S") || !defined("iAUTH") || $aid != iAUTH) fallback("../index.php");
if (isset($shout_id) && !isNum($shout_id)) fallback(FUSION_SELF.$aidlink);

if (file_exists(INFUSIONS."shoutbox_panel/locale/".$settings['locale'].".php")) {
	include INFUSIONS."shoutbox_panel/locale/".$settings['locale'].".php";
} else { include INFUSIONS."shoutbox_panel/locale/English.php"; }

$rows_per_page = 20; // Number of shouts to display per page
$textcolor = "#244A60";	// sets miscellaneous text in the boxover tips.

if (!isset($action)) { $action = ""; }

if (isset($status)) {
	if ($status == "delall") {
		$title = $locale['400'];
		$message = "<b>".$numr." ".$locale['401']."</b>";
	} elseif ($status == "del") {
		$title = $locale['404'];
		$message = "<b>".$locale['405']."</b>";
	}
	opentable($title);
	echo "<div align='center'>".$message."</div>\n";
	closetable();
	tablebreak();
}

if ($action == "deleteshouts") {
	$deletetime = time() - ($_POST['num_days'] * 86400);
	$result = dbquery("SELECT * FROM ".$db_prefix."shoutbox WHERE shout_datestamp < '$deletetime'");
	$numrows = dbrows($result);
	$result = dbquery("DELETE FROM ".$db_prefix."shoutbox WHERE shout_datestamp < '$deletetime'");
	redirect(FUSION_SELF.$aidlink."&status=delall&numr=$numrows");
} else if ($action == "delete") {
	$result = dbquery("DELETE FROM ".$db_prefix."shoutbox WHERE shout_id='$shout_id'");
	redirect(FUSION_SELF.$aidlink."&status=del");
} else if ($action == "ban") {
	if (!empty($shout_user) && $shout_user != 1) {
		$result = dbquery("UPDATE ".$db_prefix."users SET user_status='1' WHERE user_id='$shout_user'");
	}
	redirect(FUSION_SELF.$aidlink);
} else if ($action == "unban") {
	if (!empty($shout_user) && $shout_user != 1) {
		$result = dbquery("UPDATE ".$db_prefix."users SET user_status='0' WHERE user_id='$shout_user'");
	}
	redirect(FUSION_SELF.$aidlink);
} else {
	if (isset($_POST['saveshout'])) {
		if ($action == "edit") {
			$shout_message = str_replace("\n", " ", $_POST['shout_message']);
			$shout_message = preg_replace("/^(.{400}).*$/", "$1", $shout_message);
			$shout_message = preg_replace("/([^\s]{45})/", "$1\n", $shout_message);
			$shout_message = trim(stripinput(censorwords($shout_message)));
			$shout_message = str_replace("\n", "<br>", $shout_message);
		
			// Added by Yuras. Scan for links in the shout. If there is, replace it with [URL]
		
			$i = 0; $ShoutNew = "";
			$ShoutArray = explode(" ",$shout_message);
			foreach($ShoutArray as $ShoutPart) {
				$ShoutPart = str_replace("<br>", "", $ShoutPart);
				if (eregi("http:\/\/", $ShoutPart)) {
					// fix for users adding text to the beginning of links: HACKhttp://www.website.com
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"http://");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a target='_blank' href='$ShoutPart'><b>Click Me!</b></a>&#93;";
				} elseif (eregi("ftp:\/\/", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"ftp://");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a target='_blank' href='$ShoutPart'>FTP</a>&#93;";
				} elseif (eregi("irc:\/\/", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"irc://");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a href='$ShoutPart'>IRC</a>&#93;";
				} elseif (eregi("teamspeak:\/\/", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"teamspeak://");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a href='$ShoutPart'>TeamSpeak</a>&#93;";
				} elseif (eregi("aim:goim", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"aim:goim");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a href='$ShoutPart'>AIM</a>&#93;";
				} elseif (eregi("gopher:\/\/", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"gopher://");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a href='$ShoutPart'>Gopher</a>&#93;";
				} elseif (eregi("mailto:", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"mailto:");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a href='$ShoutPart'>E-Mail</a>&#93;";
				} elseif (eregi("www\.", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"www.");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutPart = "http://" . $ShoutPart;
					$ShoutNew[$i] = "&#91;<a target='_blank' href='$ShoutPart'>URL</a>&#93;";
				} elseif ((eregi("\.com", $ShoutPart)) OR (eregi("\.net", $ShoutPart)) OR (eregi("\.org", $ShoutPart)) OR (eregi("\.mil", $ShoutPart)) OR (eregi("\.gov", $ShoutPart)) OR (eregi("\.info", $ShoutPart)) OR (eregi("\.us", $ShoutPart)) OR (eregi("\.biz", $ShoutPart)) OR (eregi("\.tv", $ShoutPart)) OR (eregi("\.cc", $ShoutPart)) OR (eregi("\.ws", $ShoutPart)) OR (eregi("\.name", $ShoutPart)) OR (eregi("\.pro", $ShoutPart)) OR (eregi("\.co\.uk", $ShoutPart)) OR (eregi("\.ca", $ShoutPart)) OR (eregi("\.de", $ShoutPart)) OR (eregi("\.jp", $ShoutPart)) OR (eregi("\.ro", $ShoutPart)) OR (eregi("\.be", $ShoutPart)) OR (eregi("\.fm", $ShoutPart)) OR (eregi("\.ms", $ShoutPart)) OR (eregi("\.tc", $ShoutPart)) OR (eregi("\.co\.za", $ShoutPart)) OR (eregi("\.co\.nz", $ShoutPart)) OR (eregi("\.ph", $ShoutPart)) OR (eregi("\.dk", $ShoutPart)) OR (eregi("\.st", $ShoutPart)) OR (eregi("\.ac", $ShoutPart)) OR (eregi("\.gs", $ShoutPart)) OR (eregi("\.vg", $ShoutPart)) OR (eregi("\.sh", $ShoutPart)) OR (eregi("\.kz", $ShoutPart)) OR (eregi("\.as", $ShoutPart)) OR (eregi("\.lt", $ShoutPart)) OR (eregi("\.to", $ShoutPart)) OR (eregi("\.co\.il", $ShoutPart))) {
					$ShoutPart = "http://" . $ShoutPart;
					$ShoutNew[$i] = "&#91;<a target='_blank' href='$ShoutPart'>URL</a>&#93;";
				} elseif (strlen($ShoutPart) > 45) {
					$ShoutNew[$i] = wordwrap($ShoutPart, 45, " ", 1);
				} else { $ShoutNew[$i] = $ShoutPart; }
				$i++;
			}
			$shout_message = addslashes(implode(" ", $ShoutNew));
			// End

			$result = dbquery("UPDATE ".$db_prefix."shoutbox SET shout_message='$shout_message' WHERE shout_id='$shout_id'");
			redirect(FUSION_SELF.$aidlink);
		}
	}
	if ($action == "edit") {
		$data = dbarray(dbquery("SELECT * FROM ".$db_prefix."shoutbox WHERE shout_id='$shout_id'"));
		opentable($locale['420']);
		echo "<form name='editform' method='post' action='".FUSION_SELF.$aidlink."&amp;action=edit&amp;shout_id=".$data['shout_id']."'>
<table align='center' cellpadding='0' cellspacing='0'>
<tr>
<td class='tbl'>".$locale['421']."</td>
</tr>
<tr>
<td class='tbl'><textarea name='shout_message' rows='3' class='textbox' style='width:250px;'>".str_replace("<br>", "", $data['shout_message'])."</textarea></td>
</tr>
<tr>
<td align='center' class='tbl'><input type='submit' name='saveshout' value='".$locale['422']."' class='button'></td>
</tr>
</table></form>\n";
		closetable();
		tablebreak();
	}
	opentable($locale['440']);
	$result = dbquery("SELECT * FROM ".$db_prefix."shoutbox");
	$rows = dbrows($result);
	if (!isset($rowstart) || !isNum($rowstart)) $rowstart = 0;
	echo "<form name='deleteform' method='post' action='".FUSION_SELF.$aidlink."&amp;action=deleteshouts'>\n<div align='center'>\n";
	if ($rows != 0) {
		if ($rowstart == 0) {
			$opts = "<option value='90'>90</option>
<option value='60'>60</option>
<option value='30'>30</option>
<option value='20'>20</option>
<option value='10'>10</option>\n";
			echo $locale['430']." <select name='num_days' class='textbox' style='width:50px'>$opts</select>".$locale['431']."<br><br>
<input type='submit' name='deleteshouts' value='".$locale['432']."' class='button'><br><hr>
</div>
</form>\n";
		}
		$i = 0;
		$result = dbquery("SELECT * FROM ".$db_prefix."shoutbox LEFT JOIN ".$db_prefix."users
			ON ".$db_prefix."shoutbox.shout_name=".$db_prefix."users.user_id
			ORDER BY shout_datestamp DESC LIMIT $rowstart, $rows_per_page"
		);
		echo "<table align='center' cellpadding='0' cellspacing='1' width='100%' class='tbl-border'>\n";
		while ($data = dbarray($result)) {
			echo "<tr>\n<td class='".($i % 2 == 0 ? "tbl1" : "tbl2")."'><span class='comment-name'>";

/*******************************************************************
* Modded for user ban display names, send private message and member homepage.
*******************************************************************/

			if (iMEMBER) {
				if ($data['user_id'] == $userdata['user_id']) {
					echo "<img alt='' src='".THEME."images/bullet.gif'> ";
				} elseif ($data['user_status'] != 1) {
					if (!isset($data['user_id'])) { echo "<img alt='' src='".THEME."images/bullet.gif'> "; }
					elseif ($data['user_id'] != $userdata['user_id']) {
						echo "<a href='".BASEDIR."messages.php?msg_send=".$data['user_id']."'><img src='".INFUSIONS."shoutbox_panel/images/pm.png' title=\"header=[<img src='".INFUSIONS."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_007']."] body=[".phpentities($locale['fb_035'])."] delay=[0] fade=[on]\" alt=''></a> ";
						if ($data['user_web']) {
							if (!strstr($data['user_web'], "http://")) { $urlprefix = "http://"; } else { $urlprefix = ""; }
							echo "<a href='".$urlprefix."".$data['user_web']."' target='_blank'><img alt='' src='".INFUSIONS."shoutbox_panel/images/w3.png' title=\"header=[<img src='".INFUSIONS."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_013']."] body=[".phpentities($locale['fb_037'])."] delay=[0] fade=[on]\"></a> ";
						}
					}
				} elseif ($data['user_status'] == 1) {
					echo "<img alt='' style='vertical-align:middle;' src='".INFUSIONS."shoutbox_panel/images/banned.png' title=\"header=[<img src='".INFUSIONS."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_012']."] body=[".phpentities($locale['fb_038'])."] delay=[0] fade=[on]\">";
				}
			} else {
				if ($data['user_status'] == 1) {
					echo "<img alt='' style='vertical-align:middle;' src='".INFUSIONS."shoutbox_panel/images/banned.png' title=\"header=[<img src='".INFUSIONS."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_012']."] body=[".phpentities($locale['fb_038'])."] delay=[0] fade=[on]\">";
				} else { echo "<img alt='' src='".THEME."images/bullet.gif'> "; }
			}

/*******************************************************************
* End ban display names.
*******************************************************************/

/*******************************************************************
* Modded for colored names.
*******************************************************************/

			$shoutcount = dbcount("(shout_id)", "shoutbox", "shout_name='".$data['user_id']."'");
			if ($data['user_level'] == "103") { $userx = "<font color='#F75013'><b>".$data['user_name']."</b></font>"; }
			elseif ($data['user_level'] == "102") { $userx = "<font color='#008000'><b>".$data['user_name']."</b></font>"; }
			elseif ($data['user_level'] == "101") { $userx = "<font color='#3333CC'><b>".$data['user_name']."</b></font>"; }
			if ($data['user_status'] == 1) { $userx = "<font color='#A38C54'><b>".$data['user_name']."</b></font>"; }

/*******************************************************************
* End color mod.
*******************************************************************/

			$lastseen = time() - $data['user_lastvisit'];
			if ($lastseen < 60) {
				$lastseen = "<img src='".INFUSIONS."shoutbox_panel/images/online.png' title=\"header=[<img src='".INFUSIONS."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_014']."] body=[<font color='red'><b>".phpentities($data['user_name']."</b></font>, ".$locale['fb_040'])."] delay=[0] fade=[on]\" alt='' style='vertical-align: middle;'>";
			} else {
				$lastseen = "<img src='".INFUSIONS."shoutbox_panel/images/offline.png' title=\"header=[<img src='".INFUSIONS."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_015']."] body=[<font color='red'><b>".phpentities($data['user_name']."</b></font>, ".$locale['fb_041'])."] delay=[0] fade=[on]\" alt='' style='vertical-align: middle;'>";
			}
			if ($data['user_status'] == 1) {
				echo "<span style='cursor:default; text-decoration: none;' title=\"header=[".$data['user_name']." - <font color='red'>".$locale['fb_033']."</font>] body=[".rawurlencode("<center><img src='".INFUSIONS."shoutbox_panel/images/banned.gif'></center></span><br><br>
<font color='$textcolor'><b>".$locale['fb_025']."</b>".$data['user_name']." - <b><font color='red'><i>".$locale['fb_026']."</i></b></font><br><br>
<font color='$textcolor'><b>".$locale['fb_027']."</b>".$locale['fb_028']."<br><br>
<b>".$locale['fb_029']."</b>".showdate("shortdate", $data['user_joined'])."<br><br>
<b>".$locale['fb_030']."</b>".showdate("shortdate", $data['user_lastvisit'])."<br><br>
<b>".$locale['fb_031']."</b>$shoutcount ".$locale['fb_032']."")."] delay=[0] fade=[on]\">
<a href='".INFUSIONS."shoutbox_panel/banned.php?shout_user=".$data['shout_name']."' onClick=\"MyWindow=window.open('".INFUSIONS."shoutbox_panel/banned.php?shout_user=".$data['shout_name']."','shoutbox','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,width=240,height=250'); return false;\" class='side'>$userx</a>
</span> - <font color='red'>".$locale['fb_022']."</font>";
			} else {
				if ($data['user_name']) {
					if ($data['user_avatar'] != "") { $avatar = "<img src='".IMAGES."avatars/".$data['user_avatar']."'>"; }
					else { $avatar = "<img src='".IMAGES."noimage.gif'>"; }
					echo "<span style='cursor:default; text-decoration: none;' title=\"header=[".$data['user_name']."] body=[".rawurlencode("<center>$avatar</center></span><br><br>
<span class='$textcolor'><b>".$locale['fb_025']."</b>$userx<br><br>
<b>".$locale['fb_027']."</b>".getuserlevel($data['user_level'])."<br><br>
<b>".$locale['fb_029']."</b>".showdate("shortdate", $data['user_joined'])."<br><br>
<b>".$locale['fb_030']."</b>".showdate("shortdate", $data['user_lastvisit'])." <br><br>
<b>".$locale['fb_031']."</b>$shoutcount ".$locale['fb_032']."")."] delay=[0] fade=[on]\">
<a href='".BASEDIR."profile.php?lookup=".$data['user_id']."' class='side'>$userx</a>
</span>&nbsp;$lastseen";
				} else { echo "<span class='small'>".$data['shout_name']."</span>\n"; }
			}
			echo "</span><br>
<span class='small'>".$locale['fb_042'].showdate("longdate", $data['shout_datestamp'])."</span><br>
<span class='shoutbox'>".str_replace("<br>", "", parseshoutubb(parseubb(parsesmileys($data['shout_message']))))."</span><br>\n";
			if (iADMIN && checkrights("S")) {
				echo "<span class='small'><a href='".ADMIN."shoutbox.php".$aidlink."&amp;action=edit&amp;shout_id=".$data['shout_id']."'>".$locale['048']."</a> - <a href='".FUSION_SELF.$aidlink."&amp;action=delete&amp;shout_id=".$data['shout_id']."'>".$locale['fb_043']."</a> - ";
				if ($data['user_status'] == "1") {
					echo "<a href='".FUSION_SELF.$aidlink."&amp;action=unban&amp;shout_user=".$data['user_id']."'>".$locale['fb_009']."</a> - ";
				} elseif ($data['user_status'] == "0" && $data['user_level'] != "103") {
					echo "<a href='".FUSION_SELF.$aidlink."&amp;action=ban&amp;shout_user=".$data['user_id']."'>".$locale['fb_010']."</a> - ";
				}
				echo "</span><b>".$locale['443'].$data['shout_ip']."</b>\n";
			}
			echo "
</td>
</tr>\n";
			$i ++;
		}
		echo "</table>\n";
	} else { echo "<center><br>\n".$locale['444']."<br><br>\n</center>\n"; }
	closetable();
	echo "<div align='center' style='margin-top:5px;'>\n".makePageNav($rowstart, $rows_per_page, $rows, 3, FUSION_SELF.$aidlink."&amp;")."\n</div>\n";
}

echo "</td>\n";
require_once BASEDIR."footer.php";
?>